/************************************************
              Class Tree

This class define the Tree objects used within
the 15-111/200 Mastery Exam/Fall 2002

Students are not permitted to modify or augment
this class in any way. This file must not change.

You are not required to understand the implementation
of these methods. But, it will likely be useful
for you to understand what they can accomplish
for you.

Exam for 15-111/200  Fall 2002

*************************************************/

public class Tree implements Comparable
{
  // Ignore this. It just defines the end-of-line character
  static String eol = System.getProperty ("line.separator");

  // These are the properties of a Tree.
  private int heightInFeet;
  private double priceInDollarsAndCents;
  private int qualityFrom1Through10;      // 1 is worst, 10 is best 

  /**
    * This is the constructor of a Tree.
    * @heightInFeet is the height of the Tree measured in whole feet.
    * @priceInDollarsAndCents is the selling price of the Tree.
    * @qualityFrom1Through10 is the quality of the Tree, 10 is best.
    */ 
  public Tree (int heightInFeet, double priceInDollarsAndCents, 
               int qualityFrom1Through10)
  {
    this.heightInFeet = heightInFeet;
    this.priceInDollarsAndCents = priceInDollarsAndCents;
    this.qualityFrom1Through10 = qualityFrom1Through10;
  }


  /**
    * This is returns the recorded hieght of the Tree in whole feet
    * @return the height of the Tree in whole feet.
    */ 
  public int getHeightInFeet()
  {
    return heightInFeet;
  }


  /**
    * This is returns the selling price of the Tree
    * @return the selling price of the tree in dollars, with cents as 
    *  a fraction
    */ 
  public double getPriceInDollarsAndCents()
  {
    return priceInDollarsAndCents;
  }

  /**
    * This is returns the quality of the Tree 
    * @return the quality of the tree from 1-10, where 10 is best. 
    *  a fraction
    */ 
  public int getQualityFrom1Through10()
  {
    return qualityFrom1Through10;
  }


  /**
    * This compares two trees based on their heightInFeet
    * @return  0 if =, -1 if anotherTree is greater, 1, otherwise
    * value to the buyer
    */
  public int compareTo(Object anotherTree)
  {
    if (heightInFeet > ((Tree)anotherTree).heightInFeet)
      return 1;

    if (heightInFeet < ((Tree)anotherTree).heightInFeet)
      return -1;

    return 0;
  }


  /**
    * Returns a String representation of a Tree including all fields
    * @return a String containing a representation of the Tree
    */
  public String toString()
  {
    return "Tree: " + eol +
           "     Height: " + heightInFeet + "ft." + eol + 
           "     Price: $" + priceInDollarsAndCents + eol +
           "     Quality (1-10): " + qualityFrom1Through10 + eol;

  }
}
